{
key=getkey();
switch (key)
{
case 0x1b:  goto ende;              	//esc

case 0x148: {                           //Pfeil hoch
	    dummy=deltadb/10;
	    if (dummy==0) dummy=1;
	    dbmin=dbmin+dummy;
	    dbmax=dbmax+dummy;
	    put_db(dbmax, deltadb);
	    break;
	    }
case 0x150: {                           //Pfeil runter
	    dummy=deltadb/10;
	    if (dummy==0) dummy=1;
	    dbmin=dbmin-dummy;
	    dbmax=dbmax-dummy;
	    put_db(dbmax, deltadb);
	    break;
	    }
case 0x14b: {				//Pfeil links => Sweep langsamer
	    if (sweep_i > 0) sweep_i--;
	    dac_inc=sweep_dac[sweep_i];
	    inttimer=sweep_t[sweep_i];
	    set_timer(inttimer);
	    out_sweeptime();
	    break;
	    }
case 0x14d: {				//Pfeil rechts => Sweep schneller
	    if (sweep_i < sweep_n ) sweep_i++;
	    dac_inc=sweep_dac[sweep_i];
	    inttimer=sweep_t[sweep_i];
	    set_timer(inttimer);
	    out_sweeptime();
	    break;
	    }
case 0x2b:  {                           //+
	    if (deltadb==10) deltadb=5;
	    if (deltadb==20) deltadb=10;
	    if (deltadb==50) deltadb=20;
	    if (deltadb==100) deltadb=50;
	    dbmin=dbmax-deltadb;
	    put_db(dbmax, deltadb);
	    break;
	    }
case 0x2d:  {                           //-
	    if (deltadb==50) deltadb=100;
	    if (deltadb==20) deltadb=50;
	    if (deltadb==10) deltadb=20;
	    if (deltadb==5) deltadb=10;
	    dbmin=dbmax-deltadb;
	    put_db(dbmax, deltadb);
	    break;
	    }
case 'p':   goto start2; 		//Preset

case 'r':   {				//Reset
	    dbmin=-110; dbmax=-10; deltadb=100;
	    goto start;
	    }
case 's':   {				//Save Messdaten to File
	    modus=3;
	    sprintf(Line2,"%i",mess_postfix);
	    mess_postfix++;
	    strcpy(Line,"Mess.");
	    strcat(Line,&Line2[1]);
	    save_trace(GridWidth,Line);
	    strcpy(Line2,"saved to ");
	    strcat(Line2,Line);
	    PutString(width-strlen(Line2)*8,0,Line2,15);
	    modus=0;
	    break;
	    }
case 'f':   ZF=ZF+fc; break;		//Frequenzkorrektur

case 'm':   {				//Display Trace
	    modus=3;
	    tseg=(segment-1)&3;
	    for (i=0; i<GridWidth; i++)
	      Trace[i]=mess[i+tseg*1024];
	    plot_trace(8,8);
	    modus=0;
	    break;
	    }

case 'M':   {				//letzten Trace lschen
	    modus=3;
	    plot_trace(8,0);
	    modus=0;
	    break;
	    }

case 't':   {                           //thru Kalibration
	    modus=3;
	    tseg=(segment-1)&3;
	    for (i=0; i<1024; i++)
	      tcal[i]=dbmess[i+tseg*1024];
	    thru=1;
	    out_thru();
	    modus=0;
	    break;
	    }

case 'T':   {                           //Thru Cal on/off
	    thru=1-thru;
	    out_thru();
	    break;
	    }

case 'e':   {                           //Autorease off/on:Speicherschirm
	    erase=1-erase;
	    break;
	    }

case 'h':   {				//hold on/off
	    if (modus!=3) modus=3;
	    else modus=0;
	    break;
	    }

case 'b':   {
	    fband++;
	    switch (fband)
	      {
	      case 1: { f_adder=ZF+69.00; band=loband; break;}
	      case 2: { f_adder=2*ZF; band=hiband; break;}
	      case 3: { f_adder=0; band=loband; fband=0;}
	      }
	    break;
	    }

case 0x12e: {				//alt c => Marker
	    if (nmark<9)
	      {
	      marker[nmark].f=0.5*(fo+fu);
	      marker[nmark].typ=0;
	      marker[nmark].rm=nmark;
	      nmark++;
	      }
	    break;
	    }

case 0x121: {				//alt f => Fix-Marker in Schirmmitte
	    if (nmark<9)
	      {
	      marker[nmark].typ=4;
	      marker[nmark].rm=nmark;
	      nmark++;
	      }
	    break;
	    }
case 0x12d: {				//alt x => Marker aus
	    if (nmark>0)
	      {
	      if (marker[nmark-1].typ==5)
		{
		nmark--;
		reset_marker(nmark);
		}
	      nmark--;
	      reset_marker(nmark);
	      }
	    break;
	    }

case 0x132: {				//alt m => Cursor auf Maximum
	    if (nmark<9)
	      {
	      marker[nmark].typ=2;
	      marker[nmark].rm=nmark;
	      nmark++;
	      }
	    break;
	    }

case 0x130: {				//alt b => Bandbreite um Maximum
	      if ((nmark>0) && (nmark<8) && (marker[nmark-1].typ==2))
	       {
	       marker[nmark].typ=3;
	       marker[nmark].rm=nmark;
	       marker[nmark].rm=marker[nmark-1].rm;
	       nmark++;
	       marker[nmark].typ=5;
	       marker[nmark].rm=nmark;
	       marker[nmark].rm=marker[nmark-1].rm;
	       nmark++;
	       }
	      else
	      if (nmark<7)
	       {
	       marker[nmark].typ=2;
	       marker[nmark].rm=nmark;
	       nmark++;
	       marker[nmark].typ=3;
	       marker[nmark].rm=nmark;
	       marker[nmark].rm=marker[nmark-1].rm;
	       nmark++;
	       marker[nmark].typ=5;
	       marker[nmark].rm=nmark;
	       marker[nmark].rm=marker[nmark-1].rm;
	       nmark++;
	       }
	    break;
	    }
case 0x113: {				//alt r => relativ zum letzten Cursor auf Maximum
	    if ((nmark<9) && (nmark>0))
	      {
	      marker[nmark].f=0.5*(fo+fu);
	      marker[nmark].typ=1;
	      marker[nmark].rm=marker[nmark-1].rm;
	      nmark++;
	      }
	    break;
	    }

case 0x149: {				//Bild auf
	    if (lrdb<-50) lrdb=lrdb+50;
	    break;
	    }

case 0x151: {				//Bild ab
            lrdb=lrdb-50;
	    break;
	    }

case 'q':   goto ende;

}
}
