	.MODEL HUGE
;	locals @@		;lokale Symbole
;	.data





	.code
	.386			;386-Befehlssatz

GfxScr	equ 0A000h
bpline	equ 1280/8



	public pascal X_ORIGIN, Y_ORIGIN, TEXTLINES, NLINES, BPCHAR
	public c set_strt
	public c set_px
	public c putpx16_0
	public c putbyte
	public c put_char
	public c putvline
	public c vinit
	public c clrend
	public c putpx16_2


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

x_origin  dw 0
y_origin  dw 0
nextbyte  dd 0
textlines dw 0
nlines	  dw 0
fontseg   dw 0
fontofs   dw 0
bpchar	  dw 0

set_px	proc c far x:byte
	mov cx,3c0h
	mov ah,20h
	mov bl,x
	and bl,7
	mov bh,13h
	mov dx,3dah
gl1:	in  al,dx
	and al,1
	jnz gl1
gl2:	in al,dx
	and al,1
	jz  gl2        ;auf Austastlcke warten
	mov dx,cx
	mov al,bh
	out dx,al
	mov al,bl
	out dx,al
	mov al,ah
	out dx,al
	ret
set_px	endp

set_strt	proc c far  ;start virtueller Bildschirm setzen
	push di
	push si
	mov cx,3c0h
	mov ah,20h
	mov bl,0
	mov bh,13h
	mov dx,3dah
hl1:	in  al,dx
	and al,1
	jnz hl1
hl2:	in al,dx
	and al,1
	jz  hl2        ;auf Austastlcke warten
	mov dx,cx
	mov al,bh
	out dx,al
	mov al,bl
	out dx,al
	mov al,ah
	out dx,al
	mov cx,y_origin
	and cx,7
	mov ax,bpline*8
	imul cx,ax
	add cx,x_origin
	mov dx,y_origin
	shr dx,3
	mov ax,4f07h
	mov bx,0
	int 10h
	pop si
	pop di
	ret

set_strt endp

putpx16_0	 proc c far  x:word, y:word
;   setzt einen Pixel bei x,y im Schreibmodus 0 mit voreingestellter Farbe

ptpx160: mov  ebx,bpline*8	;Pixels per line
	 movzx eax,y		;Zeilenindex
	 imul  ebx,eax		;# Pixels ganzer Zeilen ebx
	 movzx ecx,x		;x nach ebx mit fhrenden Nullen
	 add  ebx,ecx		;+no. of pixels in ebx
	 shr  ebx,3		;/8 => ebx enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   putp162		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
putp162: ror  ebx,16		;jetzt ebx wieder window:offset
	 and  cl,7
	 mov  ax,8000h		;welches Pixel
	 shr  ax,cl
	 or   ax,8
	 mov  dx,3ceh
	 out  dx,ax		;BitMask laden
	 mov  al,fs:[bx]	;Lesezugriff => Latch laden
	 mov  fs:[bx],al	;Pixel schreiben
	 ret
putpx16_0  endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

putpx16_2	 proc c far  x:word, y:word, color:byte
;   setzt einen Pixel bei x,y,color im Schreibmodus 2


	 mov  ax,205h		;Index 5 (Mode-Register) Wert 2 (Schreibmodus)
	 mov  dx,3ceh
	 out  dx,ax		;Schreibmodus 2 aktivieren
	 movzx ebx,x		;x nach ebx mit fhrenden Nullen
	 mov  cx,bx
	 and  cx,7		;Welches Pixel soll gesetzt werden?
	 mov  ax,8000h
	 shr  ax,cl
	 or   ax,8		;Bit-Mask in ah, Index 8 (Bitmaskregister) in al
	 out  dx,ax		;Bitmaske setzen
				;jetzt x in ebx

	 movzx edx,y		;Zeilenindex
	 mov  ecx,bpline*8	;*Pixels per line
	 imul edx,ecx		;# Pixels ganzer Zeilen edx
	 add  edx,ebx		;+no. of pixels in esi
	 shr  edx,3		;/8 => esi enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 ror  edx,16		;dx=window
	 mov  ax,gs		;aktuelles Window nach ax
	 cmp  dx,ax		;=bentigtes?
	 jz   putp161		;weiter, falls Fenster okay
	 mov  gs,dx
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow

putp161: ror  edx,16		;jetzt wieder offset in dx
	 mov  bx,dx
	 mov  al,fs:[bx]	;Lesezugriff, Daten landen in Latchregister
	 mov  al,color
	 mov  fs:[bx],al	;Farbe in Bildschirmspeicher
	 mov  ax,5h		;Index 5 (Mode-Register) Wert 0 (Schreibmodus)
	 mov  dx,3ceh
	 out  dx,ax		;Schreibmodus 0 aktivieren
	 mov  ax,0ff08h
	 out  dx,ax		;Bitmask f. alle Bits oeffnen
	 ret

putpx16_2  endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vinit	 proc c far  window:word, font:byte
; setzt Videopage vpage und setzt fs mit Videopage, gs mit window
; bestimmt Font Daten fr font

	 push bp
	 mov  ax,GfxScr
	 mov  fs,ax		;Videosegment nach fs
	 mov  ax,5h		;Index 5 (Mode-Register) Wert 0 (Schreibmodus)
	 mov  dx,3ceh
	 out  dx,ax		;Schreibmodus 0 aktivieren
	 mov  ax,0ff08h
	 out  dx,ax		;Bitmask f. alle Bits oeffnen
	 mov  dx,window 	;benoetigtes Speicherfenster nach dx
	 mov  gs,dx		;Videowindow nach gs
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ax,1130h
	 mov  bh,font
	 int  10h
	 mov  bpchar,cx
	 mov  ax,es
	 mov  fontseg,ax
	 mov  fontofs,bp
	 pop  bp
	 ret

vinit	 endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

clrend	proc c far  x:word, y:word
;	Lscht Randstreifen bei x+bpline*8,y im Schreibmodus 0
;	mit Farbe aus Set-Reset-Register
;	Rckgabewert: aktuelles Speicherfenster


	 mov dx,3c4h
	 mov ax,0f02h
	 out dx,ax		;alle Bitplanes ffnen
	 mov  dx,3ceh
	 mov  ax,0ff08h
	 out  dx,ax		;Bitmask f. alle Bits oeffnen
	 mov  eax,bpline*8	;Pixels per line
	 movzx ebx,y		;Zeilenindex
	 mul  ebx		;# Pixels ganzer Zeilen eax
	 movzx ebx,x		;x nach ebx mit fhrenden Nullen
	 add  ebx,eax		;+no. of pixels in esi
	 shr  ebx,3		;/8 => ebx enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 movzx ecx,nlines	;Schleifenzhler
clren1:	 mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   clren2		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
clren2:  ror  ebx,16		;jetzt ebx wieder window:offset
	 mov  fs:[bx],al	;8 Pixels lschen
	 add  ebx,bpline	;nchste Zeile
	 loop clren1
	 ret

clrend	 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

putvline	proc c far  x:word, y:word, y_new:word
;	Linie von (x,y) nach (x+1,y_new) ev. exclusive im Schreibmodus 0
;	mit Farbe aus Set-Reset-Register
;	Rckgabewert: aktuelles Speicherfenster



	 mov  eax,bpline	;Increment zum nchsten Pixel
	 mov  bx,y_new
	 mov  cx,y
	 mov  dx,y_origin
	 cmp  bx,dx
	 jnc  vlina
	 neg  eax
vlina:   cmp  cx,dx
	 jnc  vlinb
	 neg  eax
vlinb:	 sub  bx,cx		;#Zeilen
	 jnc  vlinc
	 neg  eax
vlinc:   test bx,8000h
	 jz   vlind
	 neg  bx
vlind:	 mov  nextbyte,eax	;nextbyte: Incrementwert Adresse
	 inc  bx
	 shr  bx,1
	 mov  es,bx		;es: #Zeilen
	 sub  bx,1
	 jnc  vline
	 jmp  ptpx160           ;nur ein Pixel zu setzen

vline:	 mov  cx,x
	 and  cl,7
	 mov  ax,8000h
	 shr  ax,cl
	 or   ax,8
	 mov  dx,3ceh
	 out  dx,ax		;Bitmask f. gewnschtes Pixel setzen

	 mov  eax,bpline*8	;Pixels per line
	 movzx ebx,y    	;Zeilenindex
	 mul  ebx		;# Pixels ganzer Zeilen eax
	 movzx ebx,x    	;x nach ebx mit fhrenden Nullen
	 add  ebx,eax		;+no. of pixels in esi
	 shr  ebx,3		;/8 => ebx enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 xor  ecx,ecx
	 mov  cx,es     	;Schleifenzhler
vline1:	 mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   vline2		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
vline2:  ror  ebx,16		;jetzt ebx wieder window:offset
	 mov  al,fs:[bx]
	 mov  fs:[bx],al	;Pixel schreiben
	 add  ebx,nextbyte	;nchste Zeile
	 loop vline1

	 mov  cx,x
	 inc  cx                ;naechster x-Wert
	 and  cl,7
	 test cl,7              ;in naechstem Byte?
	 jnz  vlinx0
	 inc  ebx
vlinx0:	 mov  ax,8000h
	 shr  ax,cl
	 or   ax,8
	 mov  dx,3ceh
	 out  dx,ax		;Bitmask f. gewnschtes Pixel setzen

	 mov  cx,es     	;Schleifenzhler
vlinx1:	 mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   vlinx2		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
vlinx2:  ror  ebx,16		;jetzt ebx wieder window:offset
	 mov  al,fs:[bx]
	 mov  fs:[bx],al	;Pixel schreiben
	 add  ebx,nextbyte	;nchste Zeile
	 loop vlinx1
	 ret

putvline endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

putbyte	proc c far  x:word, y:word, data:byte
;	schreibt ein Byte in Bildspeicher
;	mit Farbe aus Set-Reset-Register


	 mov  dx,3ceh
	 mov  ax,0ff08h
	 out  dx,ax		;Bitmask f. alle Bits oeffnen
	 mov  ax,1
	 out  dx,ax             ;ENABLE SET/RESET => Daten von CPU
	 mov  eax,bpline*8	;Pixels per line
	 movzx ebx,y		;Zeilenindex
	 mul  ebx		;# Pixels ganzer Zeilen eax
	 movzx ebx,x		;x nach ebx mit fhrenden Nullen
	 add  ebx,eax		;+no. of pixels in esi
	 shr  ebx,3		;/8 => ebx enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 mov  ecx,1		;Schleifenzhler
putbyt1: mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   putbyt2		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
putbyt2: ror  ebx,16		;jetzt ebx wieder window:offset
	 mov  al,data
	 mov  fs:[bx],al	;8 Pixels schreiben
	 add  ebx,bpline	;nchste Zeile
	 loop putbyt1
	 ret

putbyte	 endp


put_char proc c far  x:word, y:word, data:byte
;	schreibt ein Zeichen aus Standardfont bei x+bpline*8,y
;	im Schreibmodus 0 mit Farbe aus Set-Reset-Register

	 push si
	 mov  ax,fontseg
	 mov  es,ax		;Fontsegment nach es
	 mov  dx,3ceh
	 mov  ax,0ff08h
	 out  dx,ax		;Bitmask f. alle Bits oeffnen
	 mov  ax,1
	 out  dx,ax             ;ENABLE SET/RESET => Daten von CPU
	 mov  eax,bpline*8	;Pixels per line
	 movzx ebx,y		;Zeilenindex
	 mul  ebx		;# Pixels ganzer Zeilen eax
	 movzx ebx,x		;x nach ebx mit fhrenden Nullen
	 add  ebx,eax		;+no. of pixels in esi
	 shr  ebx,3		;/8 => ebx enthlt # Bytes vom Ursprung
				;also Offset => edx=window:offset
	 movzx ecx,bpchar	;Schleifenzhler
	 movzx si,data
	 imul si,cx
	 add  si,fontofs	;Zeichenoffset bestimmen

putcha1: mov  ax,gs		;Istwindow nach ax
	 ror  ebx,16		;bx=Sollwindow
	 cmp  bx,ax		;=bentigtes?
	 jz   putcha2		;weiter, falls Fenster okay
	 mov  ax,4f05h		;VESA Interrupt vorbereiten
	 mov  edx,ebx
	 mov  gs,dx		;neues Window retten
	 mov  bx,0		;um Speicherfenster zu wechseln
	 int  10h		;SetMemWindow
	 mov  ebx,edx
putcha2: ror  ebx,16		;jetzt ebx wieder window:offset
	 mov  al,es:[si]
	 inc  si
	 mov  fs:[bx],al	;8 Pixels schreiben
	 mov  fs:[bx+bpline],al	;8 Pixels schreiben
	 add  ebx,2*bpline	;nchste Zeile
	 loop putcha1
	 pop  si
	 ret

put_char endp
	 end
